/*
 * Copyright (c) 1983 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
/*+:EDITS:*/
/*:05-08-1990-15:29-wht@n4hgf-rawthru */
/*:05-08-1990-15:28-wht@n4hgf-mv tipout.c tipout-orig.c */

#ifndef lint
static char sccsid[] = "@(#)tipout.c	5.2 (Berkeley) 9/2/88";
#endif /* not lint */

#include "tip.h"
/*
 * tip
 *
 * lower fork of tip -- handles passive side
 *  reading from the remote host
 */

static	jmp_buf sigbuf;

/*
 * TIPOUT wait state routine --
 *   sent by TIPIN when it wants to posses the remote host
 */
sigfunc_t
intIOT()
{

	write(repdes[1],&ccc,1);
	read(fildes[0], &ccc,1);
	longjmp(sigbuf, 1);
}

/*
 *  Accepts changes of tip variables over the pipe and acts accordingly
 */
sigfunc_t
intEMT()
{
	char c, line[256];
	register char *pline = line;
	char reply;

	read(fildes[0], &c, 1);
	while (c != '\n') {
		*pline++ = c;
		read(fildes[0], &c, 1);
	}
	*pline = '\0';
	
	/* DEBUG
	printf("intEMT::%s\r\n",line);
	*/
	
	
	pline = line;
	while(*pline != ':') pline++;
	*pline = '\0';
	pline++;
	/* then line: varible name, pline: new data */
	
	if(equal(line,vname(SCRIPT)))
	{	if (boolean(value(SCRIPT)) && fscript != NULL)
		fclose(fscript);
		if (*pline == '\0'){
			boolean(value(SCRIPT)) = FALSE;
			reply = 'y';
		} else {
			if ((fscript = fopen(pline, "a")) == NULL)
				reply = 'n';
			else {
				reply = 'y';
				boolean(value(SCRIPT)) = TRUE;
			}
		}
		write(repdes[1], &reply, 1);
	}
	else if(equal(line,vname(PARITY))){
		value(PARITY) = makstr(pline);
		setparity();
	} else if(equal(line,vname(LANGTYPE))){
		value(LANGTYPE) = makstr(pline);
		setpio();
	}
	longjmp(sigbuf, 1);
}

sigfunc_t
intTERM()
{

	if (boolean(value(SCRIPT)) && fscript != NULL)
		fclose(fscript);
	finish();
}

sigfunc_t
intSYS()
{

	boolean(value(BEAUTIFY)) = !boolean(value(BEAUTIFY));
	longjmp(sigbuf, 1);
}


/* tipx */
extern int rawthru;
sigfunc_t
int_tipout_rawthru_on()
{
	rawthru = 1;
}
sigfunc_t
int_tipout_rawthru_off()
{
	rawthru = 0;
}



/*
 * ****TIPOUT   TIPOUT****
 */
/* tipx */
#define	ALLSIGS	sigmask(SIGEMT)|sigmask(SIGTERM)|sigmask(SIGIOT)|sigmask(SIGSYS)|sigmask(SIGUSR1)|sigmask(SIGUSR2)

/* tip: ----
#define	ALLSIGS	sigmask(SIGEMT)|sigmask(SIGTERM)|sigmask(SIGIOT)|sigmask(SIGSYS)
*/

/*
 *	tipout() read chars from modem and put them to stdout.
 *	- Kenar -
 */
tipout()
{
	lett buf[BUFSIZ];
	register lett *cp;
	register int cnt;
	extern int errno;
	int omask;

	signal(SIGINT, SIG_IGN);
	signal(SIGQUIT, SIG_IGN);
	signal(SIGEMT, intEMT);		/* attention from TIPIN */
	signal(SIGTERM, intTERM);	/* time to go signal */
	signal(SIGIOT, intIOT);		/* scripting going on signal */
	signal(SIGHUP, intTERM);	/* for dial-ups */
	signal(SIGSYS, intSYS);		/* beautify toggle */
	/* tipx */
	signal(SIGUSR1, int_tipout_rawthru_on);
	signal(SIGUSR2, int_tipout_rawthru_off);


	(void) setjmp(sigbuf);
		
	for(;;)
	{	cnt = pread(buf, BUFSIZ);
		/*	Here all chars in port buffer are read.		 */
		/*
		 *	If buffer is empty, pread wait at least one char is received.
		 *	-Kenar -
	     */
		if (cnt < 0)
		{	/* lost carrier */
			if(errno == EIO)
			{	sigblock(sigmask(SIGTERM));
				intTERM();
				/*NOT REACHED*/
			}
			else continue;
		}
		else if(cnt > 0)
		{	/* block signals while writing. -Kenar - */
			omask = sigblock(ALLSIGS);
			write(1,buf,cnt);
			if (boolean(value(SCRIPT)) && fscript != NULL)
			{	if (boolean(value(BEAUTIFY)))
				{	for (cp = buf; cp < buf + cnt; cp++)
						if (!(*cp < ' ') ||
						any(*cp,value(EXCEPTIONS)))
							putc(*cp, fscript);
				}
				else
					fwrite(buf, 1, cnt, fscript);
			}
			sigsetmask(omask);
		}
	};
}
